<!DOCTYPE html>

<html lang="en">
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width">
	<title>Plaiframe Docs Source: ne.js</title>

	<!--[if lt IE 9]>
	<script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
	<![endif]-->
	<link type="text/css" rel="stylesheet" href="styles/sunlight.default.css">

	<link type="text/css" rel="stylesheet" href="styles/site.cosmo.css">

</head>

<body>

<div class="navbar navbar-default navbar-fixed-top navbar-inverse">
<div class="container">
	<div class="navbar-header">
		<a class="navbar-brand" href="index.html">Plaiframe Docs</a>
		<button class="navbar-toggle" type="button" data-toggle="collapse" data-target="#topNavigation">
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
			<span class="icon-bar"></span>
        </button>
	</div>
	<div class="navbar-collapse collapse" id="topNavigation">
		<ul class="nav navbar-nav">
			
			<li class="dropdown">
				<a href="modules.list.html" class="dropdown-toggle" data-toggle="dropdown">Modules<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-session.html">session</a></li><li><a href="module-variables.html">variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="classes.list.html" class="dropdown-toggle" data-toggle="dropdown">Classes<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="module-errors-DesignError.html">errors~DesignError</a></li><li><a href="module-game-Game.html">game~Game</a></li><li><a href="module-medley-Log.html">medley~Log</a></li><li><a href="module-medley-Queue.html">medley~Queue</a></li><li><a href="module-mongo-Database.html">mongo~Database</a></li><li><a href="module-mongo-Collection.html">mongo~Collection</a></li><li><a href="module-mongo-Document.html">mongo~Document</a></li><li><a href="module-ne-Database.html">ne~Database</a></li><li><a href="module-ne-Collection.html">ne~Collection</a></li><li><a href="module-ne-Document.html">ne~Document</a></li><li><a href="module-session-Session.html">session~Session</a></li><li><a href="module-variables-Variables.html">variables~Variables</a></li>
				</ul>
			</li>
			
			<li class="dropdown">
				<a href="externals.list.html" class="dropdown-toggle" data-toggle="dropdown">Externals<b class="caret"></b></a>
				<ul class="dropdown-menu ">
					<li><a href="external-Object.html">Object</a></li>
				</ul>
			</li>
			
		</ul>
        
            <div class="col-sm-3 col-md-3">
                <form class="navbar-form" role="search">
                    <div class="input-group">
                        <input type="text" class="form-control" placeholder="Search" name="q" id="search-input">
                        <div class="input-group-btn">
                            <button class="btn btn-default" id="search-submit"><i class="glyphicon glyphicon-search"></i></button>
                        </div>
                    </div>
                </form>
            </div>
        
	</div>

</div>
</div>


<div class="container" id="toc-content">
<div class="row">

	
	<div class="col-md-12">
	
		<div id="main">
			

		<h1 class="page-title">Source: ne.js</h1>
    
<section>
    <article>
        <pre
            class="sunlight-highlight-javascript linenums">/**
* Structures access to the embedded [NeDB database](https://www.npmjs.com/package/nedb)
*
* extends mongo.js collection and document class to allow nedb and mongodb to be interchangeable
*
* this module (unlike the mongo module) does not provide a client variable!
* 
* @requires nedb-promises
* @requires events
*
* @requires mongo
* @requires file
*
* @module ne
* @copyright Lasse Marburg 2020
* @license GPLv3
*/

var NeDB = require('nedb-promises')
const events = require('events')

const mongo = require('./mongo.js')
const file = require('./file.js')

/** nedb data directory 
 * @default 
 */
var path = "./data"

/**
* get nedb data path from config and create nedb data directory
*/
function start(config) {
	return new Promise((resolve, reject) => {
		if(config.files) {
			path = config.files
		}
		
		if(!file.exists(path)) {
			log.info("NeDB", "Create data directory: " + path)
			file.mkdir(path)
		}
		
		log.info("NeDB", "Accessing Data files in " + path)
		return resolve("started")
	})
}

/**
* abstract function. No need to stop NeDB
*/
function stop() {
  
}

/**
* Allows access to a Database.
*
* For the NeDB module a Database is represented by a folder that contains data files for each collection
*
* @param {Object} config
* @param {String} config.name - database ID
* @param {number} [config.url] - host and port of mongoDB and replikas. Optional if start() function was called
*
*/
class Database extends mongo.Database {
  constructor(config) {
		super(config)
		
		this.type = "nedb"
		
		this.path = path + '/' + this.name
  }
  
  /**
  * check if database folder already exists, then create collection objects of each file
  * else return that database is new
  */
  connect() {
    return new Promise((resolve, reject) => {
      this.db = {}
      
      if(file.mkdir(this.path)) {
        file.ls(path + '/' + this.name).forEach(file => {
          var connector = new NeDB({filename: this.path + '/' + file})
          this[file] = new Collection(file, connector, this.name)
          log.debug(this.name, "Created collection Object of: " + file)
      	})
        return resolve("connected")
      } else {
        return resolve("created")
      }
    })
  }
	
	/**
	* return all collections in this databse as a list of strings based on files in the database folder
	*
	* @returns {Promise} array of Collection names (string).
	*/
	listCollections() {
		return new Promise((resolve, reject) => {
			return resolve(file.ls(this.path))
		})
	}
  
  /**
	* adds NeDB connector and collection to Database object
	*
	* @param {String} name - new collections name
	*
	* @returns {Promise} forwards response when done
	*/
	addCollection(name) {
		return new Promise((resolve, reject) => {
      var connector = new NeDB({filename: path + '/' + this.name + '/' + name})
      connector.load()
      this[name] = new Collection(name, connector, this.name)
      log.debug(this.name, "Created collection Object of: " + name)
      return resolve("created")
		})
	}
	
	/**
	* drop the collection, delete the reference 
	* keeps the file (will be overwritten if collection with same name is created)
	*
	* @param {String} name - to be dropped collections name
	*
	* @returns {Promise} forwards response when done
	*/
	dropCollection(name) {
		return new Promise((resolve, reject) => {
			this[name].c.remove({ }, { multi: true })
			.then(result => {
				return this[name].c.load()
			})
			.then(result => {
				if(result) {
					delete this[name]
				}
				resolve(result)
			})
			.catch(error => {
				log.error(this.name, error)
			})
		})
	}
	
	/**
	* Drop Database (Delete folder and all files)
	*/
	drop() {
		let name = this.name
		if(file.rm(this.path)) {
			log.info(0, "Database " + name + " deleted")
		} else {
			log.error(0, "Failed to delete Database: " + name)
		}
	}
	
}

/**
* Collection Object represents and gives access to a NeDB file. Inherits a NeDB connector.
*
* @param {String} name - name of collection. Same as object instance name in Database Object
* @param {Object} col - Collection Object created from db connection
*/
class Collection extends mongo.Collection {
  constructor(name, nedb_connector, database_name) {
    super(name, nedb_connector)
		
		this.event = new events.EventEmitter()
		this.event_subscription = false
		
		this.database = database_name
  }
	
	/**
	* @param {Object} query - json to identify Document
	*
	* @returns {Document} easier access to first document in this collection the query returns
	*/
	document(query) {
		return new Document(query, this)
	}
	
	/**
	* start the simulation of a mongo change stream
	* dispatch change event on every (successfull) update/set/insert function call
	*
	* @returns {Object} a mongodb Change stream (https://docs.mongodb.com/manual/changeStreams/)
	*/
	changes() {
		this.event_subscription = true
		return this.event
	}
	
	/**
	* Dispatch change event with additional information on the event type and data.
	*/
	dispatchChange(changes) {
		this.event.emit("change", changes)
	}
	
	/**
	* creates Change Event Object with basic data
	*
	* similar to mongo change event:
	* https://docs.mongodb.com/manual/reference/change-events/
	*
	* Though the information about what data was updated may be inaccurate!
	* updateDescription is a simple copy of the update data Object
	*
	*/
	changeEvent(type) {
		return {
			operationType:type,
			fullDocument:{},
			updateDescription:{},
			ns : {
      	db : this.database,
      	coll : this.name
   		},
   		documentKey : { _id : undefined },
   		updateDescription : {
      	updatedFields : {},
      	removedFields : [] // should actually be an array
   		}
		}
	}
	
	/**
	* dispatch a notification about updates in the collection.
	*
	* ignore if never any module subscribed to the change event.
	*
	* @param {String} type - either update or remove
	* @param {Object} query - query of original update command
	* @param {Object} before - document before update command
	* @param {Object} after - document after update command
	*/
	updateEvent(type, query, before, after) {
		if(!after) { return }
		if(!this.event_subscription) { return }
		
		let changes = this.changeEvent(type)
		
		changes.fullDocument = after
		changes.documentKey._id = after._id
		
		let diff = Object.changes(before, after)
		changes.updateDescription.updatedFields = diff.updated
		changes.updateDescription.removedFields = diff.removed
				
		this.dispatchChange(changes)
	}
	
	/**
	* compare two _ids and return if they are equal
	* Dummy function to keep mongo and NeDB interchangeable
	* mongo creates _id Objects that can not be compared with ==
	*
	* @param {String} idA - id to be checked against idB
	* @param {String} idB - id to be checked against idA
	*
	* @returns {boolean} true if ids are equal
	*/
	compareIDs(idA, idB) {
		return (idA == idB)
	}

	/**
	* Dummy function to keep mongo and NeDB interchangeable
	*
	* @param {string} id - id to be transformed
	* @returns {string} unchanged id string
	*/
	makeID(id) {
		return id
	}
	
  /**
	* get list of Documents based on query
	*
	* @param {Object} query - check docuemnts against query
	*
	* @returns {Promise} forwards an array of all found documents. Returns no rejection!
	*/
	find(query) {
		return new Promise((resolve, reject) => {
			this.c.find(query)
				.then(result => {
					resolve(this.decode(result))
				})
				.catch(error => {
					log.error(this.name, error)
				})
		});
	}
	
	/**
  * get specific element of Documents based on query.
  *
	* @param {Object} key - define key in documents you want to have returned
  * @param {Object} query - check documents against query
  *
  * @returns {Promise} forwards an array of all found document keys. No rejection!
  */
	distinct(key, query) {
		return new Promise((resolve, reject) => {
			this.find(query)
				.then(result => {
					if(!result.length) {return resolve([])}
					
					let dist = result.map(r => {return Object.getPath(r, key)})
					
					if(!dist) {return resolve([])}
					
					return resolve(dist)
				})
				.catch(error => {
					log.error(this.name, error)
				})
		});
	}
  
  /**
	*
	*  
	* @param {Object} query - check documents against query
	* @param {Object} sortBy - sort returned documents based on this object.
	*/
	sorted(query, sortBy) {
		return new Promise((resolve, reject) => {
			this.c.find(query).sort(sortBy)
				.then(result => {
					resolve(this.decode(result))
				})
				.catch(error => {
					log.error(this.name, error)
				})
		})
	}
	
	pick(query, path, sub_query) {
		return new Promise((resolve, reject) => {
			this.distinct(path, query)
			.then(result => {
				if(!result.length) {
						return resolve(undefined)
				}
				if(!Array.isArray(result[0])) {return resolve(undefined)}
				
				return this.temp(result[0])
			})
			.then(result => {
				if(!result) {return resolve(undefined)}
				return result.find(sub_query)
			})
			.then(result => {
				if(!result) {return resolve({})}
				if(!result.length) {return resolve({})}
				return resolve(result[0])
			})
			.catch(error => {
				log.error(this.name, error)
			})
		})
		
	}
	
	/**
	* create a temporary NeDatabase filled with a list of initial documents.
	*
	* @returns {Promise} NeDB connector 
	*/
	temp(list) {
		return new Promise((resolve, reject) => {
			if(!Array.isArray(list)) {return reject("temp() needs an array as argument")}
			let temp_connector = NeDB.create()
      temp_connector.load()
			.then(result => {
				temp_connector.insert(list,{multi:true})
			})
			.then(result => {
				return resolve(temp_connector)
			})
			.catch(error => {
				log.error(this.name, error)
			})
		})
	}
	
	/**
	* add new document to collection
	*
	* @returns {Promise} data about the inserted document including _id property
	*/
	insert(data) {
		return new Promise((resolve, reject) => {
			this.c.insert(this.encode(data))
				.then(res => {
					if(res) {
						let changes = this.changeEvent("insert")
						changes.fullDocument = res
						changes.documentKey._id = res._id
						this.dispatchChange(changes)
						
						res["insertedId"] = res._id
						this.feedback({insertedCount:1})
						return resolve(res)
					}
				})
				.catch(err => {
					log.error(this.name, err)
					return reject(err)
				})
		})
	}
	
	/**
	* Replace the first Document returned by query.
	* For NeDB unlike mongodb, using update without any operators replaces the queried document by the given data.
	*
	* since it calls NeDB update function it dispatches an 'update', not a 'replace' change event like mongo does
	* change event properties provide informations about what is different between the orinal and the replacing document.
	*
	* @param {Object} query - query what documents to replace
  * @param {data} data - json of how the replaced document looks like
	* @param {data} options - see replaceOne options: https://docs.mongodb.com/manual/reference/method/db.collection.replaceOne/
	*/
	replace(query, data, options) {
		return new Promise((resolve, reject) => {
			this.update(query, data)
				.then(res => {
					this.feedback(res)
					return resolve(res)
				})
				.catch(err => {
					log.error(this.name, new Error(err))
					return reject(err)
				})
		})
	}
	
	/**
	* make an update on selected documents.
	*
	* buffer the original document to allow creating a detailed change event
	*
	* @param {Object} query - query what documents to update
  * @param {data} data - json of what is to be updated
	*
	*
	* @returns {Promise} matchedCount - number of matched documents, modifiedCount - number of modified documents
	*/
	update(query, data) {
		return new Promise((resolve, reject) => {
			let before = {}
			this.find(query)
			.then(result => {
				before = result
				return this.c.update(query, this.encode(data), {multi:true, returnUpdatedDocs:true})
			})
			.then(result => {
				for(let i = 0; i&lt; result.length; i++) {
					this.updateEvent("update", query, before[i], result[i])
				}
					
				return resolve({modifiedCount:result.length, matchedCount:before.length})
			})
			.catch(err => {
					return reject(err)
			})
		})
	}
	
	/**
	* change existing document. Only objects mentioned in query are updated.
	* If you don't want to rewrite the object as a whole, use string dot notation
	* to specify the nested object
	*
	* prepends $set to updated data
	*
	* @param {Object} query - query what documents to update
	* @param {data} data - json of what is to be updated
	*
	* @returns {Promise} number of documents that where udated
	*/
	set(query, data) {
		return new Promise((resolve, reject) => {
			this.update(query, { $set: data })
				.then(result => {
					return resolve(result)
				})
				.catch(err => {
					log.error(err)
					return reject(err)
				})
		})
	}
	
	/**
	* delte documents
	*
	* @param {Object} query - documents to be deleted
	*/
	delete(query) {
		return new Promise((resolve, reject) => {
			this.slice(query)
			.then(result => {
				return resolve(result.length)
			})
			.catch(error => {
				log.error(this.name, error)
			})
		})
	}
	
	/**
	* delete documents based on query and return them
	*
	* @param {Object} query - what entries to cut out
	*
	* @returns {Promise} deleted documents as array
	*/
	slice(query) {
		return new Promise((resolve, reject) => {
			let docs = []
			this.find(query)
				.then(result => {
					docs = result
					
					return this.c.remove(query,{multi:true})
				})
				.then(result => {
					if(result) {
						let changes = this.changeEvent("delete")
						changes.documentKey._id = docs[0]._id
						this.dispatchChange(changes)
					}
					return resolve(docs)
				})
				.catch(error => {
					log.error(this.name, error)
				})
		})
	}
	
	/**
	* append item to array in object. Don't allow duplicates
	*
	* @param {Object} data - Array name/path and values to append
	*												use string with dot notation for nested array (e.g.: {'object.array':{key:value}})
	* @returns {Promise} matchedCount - number of matched documents, modifiedCount - number of modified documents
	*/
	push(query, data) {
		return new Promise((resolve, reject) => {
			let documents = 0
			this.find(query)
			.then(result => {
				documents = result	
				return this.update(query, { $addToSet: data })
			})
			.then(res => {
				resolve(res)
			})
			.catch(err => {
				log.error(this.name, err)
			})
		})
	}
}

/**
* Narrows any query down to the same document.
*
* @todo the document should not rely on the query that defined in in the init query  
* it should rather be reffered to by _id once the init query returned a document.
* But this seems to be a problem with the pick function
*
* @param {ObjectId} query - query to address one single record in mongodb
* @param {ne.Collection} collection - collection that inherits this Document
*/
class Document extends mongo.Document{
	constructor(query, collection) {
		super(query, collection)
	}
}

if (require.main === module) {
    database = new Database({name:'testNeDB'})
    database.connect()
    .then(result => {
      database.db.update({"test":0},{$set:{"yes":111}})
    })
    .catch(error => {
      console.log(error)
    })
}

module.exports = {
	Database: Database,
  Colleciton: Collection,
  start:start,
  stop:stop
}
</pre>
    </article>
</section>





		</div>
	</div>

	<div class="clearfix"></div>

	

</div>
</div>


    <div class="modal fade" id="searchResults">
      <div class="modal-dialog">
        <div class="modal-content">
          <div class="modal-header">
            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
            <h4 class="modal-title">Search results</h4>
          </div>
          <div class="modal-body"></div>
          <div class="modal-footer">
            <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
          </div>
        </div><!-- /.modal-content -->
      </div><!-- /.modal-dialog -->
    </div>


<footer>

	 | <a href='https://plaitools.gitlab.io/documentation/plaiframe/webview/'>Webview Documentation</a> | <a href='https://plaitools.gitlab.io/documentation/plaiframe/plugins/'>Plugin Documentation</a> | <a href='https://gitlab.com/plaitools'>Plaitools on Gitlab</a>


	<span class="copyright">
	© 2020 Lasse Marburg, Benedikt Kaffai
	</span>

<span class="jsdoc-message">
	Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.6.4</a>
	
		on Fri Feb 5th 2021
	
	using the <a href="https://github.com/docstrap/docstrap">DocStrap template</a>.
</span>
</footer>

<script src="scripts/docstrap.lib.js"></script>
<script src="scripts/toc.js"></script>

    <script type="text/javascript" src="scripts/fulltext-search-ui.js"></script>


<script>
$( function () {
	$( "[id*='$']" ).each( function () {
		var $this = $( this );

		$this.attr( "id", $this.attr( "id" ).replace( "$", "__" ) );
	} );

	$( ".tutorial-section pre, .readme-section pre, pre.prettyprint.source" ).each( function () {
		var $this = $( this );

		var example = $this.find( "code" );
		exampleText = example.html();
		var lang = /{@lang (.*?)}/.exec( exampleText );
		if ( lang && lang[1] ) {
			exampleText = exampleText.replace( lang[0], "" );
			example.html( exampleText );
			lang = lang[1];
		} else {
			var langClassMatch = example.parent()[0].className.match(/lang\-(\S+)/);
			lang = langClassMatch ? langClassMatch[1] : "javascript";
		}

		if ( lang ) {

			$this
			.addClass( "sunlight-highlight-" + lang )
			.addClass( "linenums" )
			.html( example.html() );

		}
	} );

	Sunlight.highlightAll( {
		lineNumbers : true,
		showMenu : true,
		enableDoclinks : true
	} );

	$.catchAnchorLinks( {
        navbarOffset: 10
	} );
	$( "#toc" ).toc( {
		anchorName  : function ( i, heading, prefix ) {
			return $( heading ).attr( "id" ) || ( prefix + i );
		},
		selectors   : "#toc-content h1,#toc-content h2,#toc-content h3,#toc-content h4",
		showAndHide : false,
		smoothScrolling: true
	} );

	$( "#main span[id^='toc']" ).addClass( "toc-shim" );
	$( '.dropdown-toggle' ).dropdown();

    $( "table" ).each( function () {
      var $this = $( this );
      $this.addClass('table');
    } );

} );
</script>



<!--Navigation and Symbol Display-->


<!--Google Analytics-->



    <script type="text/javascript">
        $(document).ready(function() {
            SearcherDisplay.init();
        });
    </script>


</body>
</html>
